Imports System
Imports System.Reflection
Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports Outlook = Microsoft.Office.Interop.Outlook
Imports Office = Microsoft.Office.Core
Imports AddinExpress.VSTO

'Add-in Express for VSTO Module
Public Class ADXModule
    Inherits AddinExpress.VSTO.ADXOutlookAddin
 
#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        CType(Me, System.ComponentModel.ISupportInitialize).BeginInit()
        '
        'ADXModule
        '
        CType(Me, System.ComponentModel.ISupportInitialize).EndInit()

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

#End Region

    Public Sub New(ByVal Application As Object)
        MyBase.New(Application)

        'This call is required by the Component Designer
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return HostApplication
        End Get
    End Property

    Private Sub ADXModule_CommandBarsUpdate(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.CommandBarsUpdate
        DoCommandBarsUpdate()
    End Sub

    Private Sub DoOpenOptionPage(ByVal Sender As Object)
        Dim Properties As Form1 = Nothing

        Try
            Properties = New Form1()
            If Properties.ShowDialog() = DialogResult.OK Then

            End If
        Finally
            If Not (Properties Is Nothing) Then
                Properties.Dispose()
            End If

        End Try
    End Sub

    Private Sub DoClick(ByVal sender As System.Object)
        MsgBox(sender.Caption)
    End Sub

    Private Function AddControl(ByVal Container As Object, ByVal CtrlType As Type, ByVal Caption As String, ByVal ControlTag As String, ByVal Before As Integer, ByVal BeginGroup As Boolean, ByVal EventHandler As Object) As AddinExpress.VSTO.ADXCommandBarControl
        Dim AdxNewControl As AddinExpress.VSTO.ADXCommandBarControl = Nothing
        Dim collection As AddinExpress.VSTO.ADXBaseControlCollection = Nothing

        collection = Container.Controls

        If Not (EventHandler Is Nothing) Then
            AdxNewControl = collection.GetControlByControlTag(ControlTag, False)
            If Not (AdxNewControl Is Nothing) Then
                Select Case CtrlType.Name
                    Case "ADXCommandBarButton"
                        RemoveHandler AdxNewControl.AsButton.Click, EventHandler
                    Case "ADXCommandBarComboBox"
                        RemoveHandler AdxNewControl.AsComboBox.Change, EventHandler
                    Case "ADXCommandBarDropDownList"
                        RemoveHandler AdxNewControl.AsDropDownList.Change, EventHandler
                    Case "ADXCommandBarEdit"
                        RemoveHandler AdxNewControl.AsEdit.Change, EventHandler
                End Select
            End If
        End If

        AdxNewControl = collection.Add(CtrlType, ControlTag, 1, Before, True)
        AdxNewControl.BeginGroup = BeginGroup
        AdxNewControl.Caption = Caption
        Select Case CtrlType.Name
            Case "ADXCommandBarButton"
                AdxNewControl.AsButton.Style = AddinExpress.VSTO.ADXMsoButtonStyle.adxMsoButtonCaption
                If Not (EventHandler Is Nothing) Then
                    AddHandler AdxNewControl.AsButton.Click, EventHandler
                End If
            Case "ADXCommandBarComboBox"
                If Not (EventHandler Is Nothing) Then
                    AddHandler AdxNewControl.AsComboBox.Change, EventHandler
                End If
            Case "ADXCommandBarDropDownList"
                If Not (EventHandler Is Nothing) Then
                    AddHandler AdxNewControl.AsDropDownList.Change, EventHandler
                End If
            Case "ADXCommandBarEdit"
                If Not (EventHandler Is Nothing) Then
                    AddHandler AdxNewControl.AsEdit.Change, EventHandler
                End If
        End Select

        Return AdxNewControl
    End Function

    Private AdxCommandBar As AddinExpress.VSTO.ADXCommandBar = Nothing

    Private Sub DoCommandBarsUpdate()
        Dim Sel As Outlook.Selection = Nothing
        Dim _NameSpace As Outlook.NameSpace = Nothing
        Dim ActiveExplorer As Outlook.Explorer = Nothing
        Dim DefaultFolder As Outlook.MAPIFolder = Nothing
        Dim CurrentFolder As Outlook.MAPIFolder = Nothing

        Try
            If (Me.HostVersion.IndexOf("9.") = 0) Then
                Return
            End If

            _NameSpace = OutlookApp.GetNamespace("MAPI")
            ActiveExplorer = OutlookApp.ActiveExplorer()

            Try
                DefaultFolder = _NameSpace.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderInbox)
                CurrentFolder = ActiveExplorer.CurrentFolder

                Try
                    Sel = ActiveExplorer.Selection
                Catch
                End Try

                Dim ContextBar As Office.CommandBar = Nothing

                If ((Not Sel Is Nothing) And (Sel.Count > 0 And CurrentFolder.EntryID = DefaultFolder.EntryID)) Then
                    Me.CommandBarsObj = ActiveExplorer.CommandBars
                    Try
                        ContextBar = Me.FindCommandBarObj("Context Menu")
                        If Not (ContextBar Is Nothing) Then
                            If (ContextBar.Controls.Count > 0) Then
                                Dim ctrl As AddinExpress.VSTO.ADXCommandBarControl = Nothing
                                Dim ButtonType As System.Type = New AddinExpress.VSTO.ADXCommandBarButton().GetType()
                                Dim PopupType As System.Type = New AddinExpress.VSTO.ADXCommandBarPopup().GetType()

                                Try
                                    If (adxCommandBar Is Nothing) Then
                                        adxCommandBar = New AddinExpress.VSTO.ADXCommandBar()
                                        adxCommandBar.CommandBarName = "Context Menu"
                                        adxCommandBar.Protection = AddinExpress.VSTO.ADXMsoBarProtection.adxMsoBarNoProtection
                                    End If

                                    AdxCommandBar.CommandBarObj = ContextBar
                                    AdxCommandBar.UpdateCommandBarObj(Me)

                                    AddControl(AdxCommandBar, ButtonType, "My Action", "MY_UNIQUE_TAG 1", 2, True, New AddinExpress.VSTO.ADXClick_EventHandler(AddressOf DoClick))
                                    AddControl(AdxCommandBar, ButtonType, "My Option Page", "MY_UNIQUE_TAG 2", 0, True, New AddinExpress.VSTO.ADXClick_EventHandler(AddressOf DoOpenOptionPage))

                                    ctrl = AddControl(AdxCommandBar, PopupType, "My Popup Menu", "MY_UNIQUE_TAG 3", 3, False, Nothing)
                                    AddControl(ctrl, ButtonType, "Popup Item 1", "MY_UNIQUE_TAG 4", 0, False, New AddinExpress.VSTO.ADXClick_EventHandler(AddressOf DoClick))
                                    AddControl(ctrl, ButtonType, "Popup Item 2", "MY_UNIQUE_TAG 5", 0, False, New AddinExpress.VSTO.ADXClick_EventHandler(AddressOf DoClick))
                                    AddControl(ctrl, ButtonType, "Popup Item 3", "MY_UNIQUE_TAG 6", 0, False, New AddinExpress.VSTO.ADXClick_EventHandler(AddressOf DoClick))

                                Catch err As Exception
                                    MessageBox.Show(err.Message, err.Source)
                                End Try
                            End If
                        End If
                    Finally
                        If Not (ContextBar Is Nothing) Then
                            Marshal.ReleaseComObject(ContextBar)
                        End If
                        Me.CommandBarsObj = Nothing
                    End Try
                End If
            Finally
                If Not (Sel Is Nothing) Then
                    Marshal.ReleaseComObject(Sel)
                End If
                If Not (DefaultFolder Is Nothing) Then
                    Marshal.ReleaseComObject(DefaultFolder)
                End If
                If Not (CurrentFolder Is Nothing) Then
                    Marshal.ReleaseComObject(CurrentFolder)
                End If
            End Try
        Finally
            If Not (_NameSpace Is Nothing) Then
                Marshal.ReleaseComObject(_NameSpace)
            End If
            If Not (ActiveExplorer Is Nothing) Then
                Marshal.ReleaseComObject(ActiveExplorer)
            End If
        End Try
    End Sub

End Class

